package com.madeu.dao.web.webeventdiet;

import jakarta.annotation.PostConstruct;
import org.mybatis.spring.SqlSessionTemplate;
import org.mybatis.spring.support.SqlSessionDaoSupport;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Repository
public class WebEventDietSqlMapDAO extends SqlSessionDaoSupport{

    @Autowired
    private SqlSessionTemplate sqlSessionTemplate;

    @PostConstruct
    void init() {
        setSqlSessionTemplate(sqlSessionTemplate);
    }

    /**
     * 홈페이지 이벤트(다이어트) 정보 총 갯수 조회 (total count)
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectTotalWebEventDietCount(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventDietSqlMapDAO selectTotalWebEventDietCount START");
        String sqlId = "WebEventDiet.selectTotalWebEventDietCount";
        logger.debug("WebEventDietSqlMapDAO selectTotalWebEventDietCount END");
        return getSqlSession().selectList(sqlId, paramMap);
    }

    /**
     * 홈페이지 이벤트(다이어트) 정보 리스트 조회 (List)
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectListWebEventDiet(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventDietSqlMapDAO selectListWebEventDiet START");
        String sqlId = "WebEventDiet.selectListWebEventDiet";
        logger.debug("WebEventDietSqlMapDAO selectListWebEventDiet END");
        return getSqlSession().selectList(sqlId, paramMap);
    }

    /**
     * 홈페이지 이벤트(다이어트) 정보 조회
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectWebEventDiet(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventDietSqlMapDAO selectWebEventDiet START");
        String sqlId = "WebEventDiet.selectWebEventDiet";
        logger.debug("WebEventDietSqlMapDAO selectWebEventDiet END");
        return getSqlSession().selectList(sqlId, paramMap);
    }

    /**
     * 홈페이지 이벤트(다이어트) 정보 등록
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public int insertWebEventDiet(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventDietSqlMapDAO insertWebEventDiet START");
        String sqlId = "WebEventDiet.insertWebEventDiet";
        logger.debug("WebEventDietSqlMapDAO insertWebEventDiet END");
        return getSqlSession().insert(sqlId, paramMap);
    }
    
    /**
     * 홈페이지 이벤트(다이어트) 파일 정보 등록
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public int insertWebEventDietContentFile(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventDietSqlMapDAO insertWebEventDietContentFile START");
        String sqlId = "WebEventDiet.insertWebEventDietContentFile";
        logger.debug("WebEventDietSqlMapDAO insertWebEventDietContentFile END");
        return getSqlSession().insert(sqlId, paramMap);
    }
    
    /**
     * 홈페이지 이벤트(다이어트) 파일 정보 등록
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public int insertWebEventDietThumbnailFile(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventDietSqlMapDAO insertWebEventDietThumbnailFile START");
        String sqlId = "WebEventDiet.insertWebEventDietThumbnailFile";
        logger.debug("WebEventDietSqlMapDAO insertWebEventDietThumbnailFile END");
        return getSqlSession().insert(sqlId, paramMap);
    }
    
    /**
     * 홈페이지 이벤트(다이어트) 시술 정보 등록
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public int insertWebEventListDiet(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventDietSqlMapDAO insertWebEventListDiet START");
        String sqlId = "WebEventDiet.insertWebEventListDiet";
        logger.debug("WebEventDietSqlMapDAO insertWebEventListDiet END");
        return getSqlSession().insert(sqlId, paramMap);
    }
    
    /**
     * 홈페이지 이벤트(다이어트) 시술 정보 업데이트
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public int updateWebEventListDiet(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventDietSqlMapDAO updateWebEventListDiet START");
        String sqlId = "WebEventDiet.updateWebEventListDiet";
        logger.debug("WebEventDietSqlMapDAO updateWebEventListDiet END");
        return getSqlSession().update(sqlId, paramMap);
    }

    /**
     * 홈페이지 이벤트(다이어트) 정보 수정
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public int updateWebEventDiet(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventDietSqlMapDAO updateWebEventDiet START");
        String sqlId = "WebEventDiet.updateWebEventDiet";
        logger.debug("WebEventDietSqlMapDAO updateWebEventDiet END");
        return getSqlSession().update(sqlId, paramMap);
    }

    /**
     * 홈페이지 이벤트(다이어트) 정보 삭제
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public int deleteWebEventDiet(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventDietSqlMapDAO deleteWebEventDiet START");
        String sqlId = "WebEventDiet.deleteWebEventDiet";
        logger.debug("WebEventDietSqlMapDAO deleteWebEventDiet END");
        return getSqlSession().update(sqlId, paramMap);
    }
    
    /**
     * 시술 정보 총 갯수 조회 (total count)
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public Integer selectTotalEventCount(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventDietSqlMapDAO selectTotalEventCount START");
        String sqlId = "WebEventDiet.selectTotalEventCount";
        logger.debug("WebEventDietSqlMapDAO selectTotalEventCount END");
        return getSqlSession().selectOne(sqlId, paramMap);
    }
    /**
     * 시술 정보 리스트 조회 (List)
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectListEvent(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventDietSqlMapDAO selectListEvent START");
        String sqlId = "WebEventDiet.selectListEvent";
        logger.debug("WebEventDietSqlMapDAO selectListEvent END");
        return getSqlSession().selectList(sqlId, paramMap);
    }
    /**
     * 시술 카테고리 정보 리스트 조회 (List)
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectWebEventDietCategory(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventDietSqlMapDAO selectWebEventDietCategory START");
        String sqlId = "WebEventDiet.selectListEventCategory";
        logger.debug("WebEventDietSqlMapDAO selectWebEventDietCategory END");
        return getSqlSession().selectList(sqlId, paramMap);
    }
    
    /**
     * 시술 카테고리 정보 시술리스트 조회 (List)
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectWebEventListDiet(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventDietSqlMapDAO selectWebEventListDiet START");
        String sqlId = "WebEventDiet.selectWebEventListDiet";
        logger.debug("WebEventDietSqlMapDAO selectWebEventListDiet END");
        return getSqlSession().selectList(sqlId, paramMap);
    }
    
}
